/*
  NVC/V810 18.14 (32-bit) fixed-point Math Library
  Amos "RunnerPack" Bieler
  Portions adapted from code supplied with the article "Doing It Fast" by Bob Pendleton
*/

#include "fix14.h"

inline fix14 fixMul(fix14 a, fix14 b)
{
#if 1
  return (((a >> 14) * (b >> 14)) << 14) + fixFract((fixFract(a) * fixFract(b)) >> 14);
#else
  // I suspect the assembly code below might be wrong, so I'm trying a C
  // version which /seems/ to work, but I don't know whether it's faster
  // than using floats...

  fix14 cob = b;
  __asm__ __volatile__(
      "mul %1,  %2\n\t"
      "shl 18,  r30\n\t"
      "shr 14,  %2\n\t"
      "or  r30, %2\n\t"
    : "=r" (cob)          /* Output */
    : "r" (a), "r" (cob)  /* Input */
    : "r30"             /* Clobber */
  );

  return cob;
#endif
}
