﻿/*
  NVC/V810 18.14 (32-bit) fixed-point Math Library
  Amos "RunnerPack" Bieler
  Portions adapted from code supplied with the article "Doing It Fast" by Bob Pendleton
*/

#ifndef FIX14_H
#define FIX14_H

typedef signed int fix14;

/* Convert between fixed-point and other numbers */
#define int2fix(n)      (fix14)((n) << 14)
#define fix2int(n)      ((n) >> 14)
#define fix2float(n)    (((float)(n)) / (1 << 14))
#define float2fix(n)    (fix14)((float)(n) * (1 << 14))

#define fixFract(n) ((n) & 0x3FFF)

/* Multiply two fixed point numbers */
inline fix14 fixMul(fix14 a, fix14 b);
// #define fixMul(a,b)   float2fix((fix2float(a) * fix2float(b)))
// This is clearly doing something different, yet I TESTED
// the "real" one, and it was WORKING FINE! What is going on?! -AB

/* Divide one fixed point number by another */
// TODO: Figure out how to make d1 64-bit (LSH by 14) to preserve its range and d2's precision.
// #define fixDiv(d1,d2)   ((((d1) << 14) / (d2)))            // Ideal (if d1 was >= 46-bits long)
// #define fixDiv(d1,d2)   ((((d1) << 7) / ((d2) >> 7)))      // Kludge (reduces d1 usable range to ±1024)
#define fixDiv(d1,d2)   float2fix((fix2float(d1) / fix2float(d2)))     // Kludge (slooooooow!)

#endif
