// This file contains sound and music notes.
//
// Each sound begins with the note length in video frames per note. To
// convert a tempo from beats per minute, use the following formula:
//
//   FramesPerNote = 50 / (BeatsPerMinute / 60)
//
// The result might not be an integer, so round up or down it as appropriate.
// It may not exceed 255 (which is about 11.75 beats per minute) because the
// FramesPerNote field of a tySound structure, where it gets copied to, is
// only 8 bits wide. It must also be larger than 1 (3000 beats per minute).
//
// The last note in the sound is either ENDSOUND, which stops the sound, or
// LOOPSOUND, which restarts it from the beginning.

// Played when the player shoots.
const u16 sndMissileLaunch[] = {
  3,
  G_4, FS4, E_4,
  ENDSOUND,
};

const u16 sndMenuBeep[] = {
  6,
  A_4,
  ENDSOUND,
};

const u16 sndMenuConfirm[] = {
  5,
  A_5, // C_3, E_3, G_3, D_3, F_3, A_3,
  ENDSOUND,
};
